#ifndef STATIC_BUFER_H_
#define STATIC_BUFER_H_



template <int size>
struct static_buffer 
{
 void * p;    
 u8 base[size];

 inline static_buffer() { p = base; }
 inline void make_empty() 
 {
  assert( p < &base[size] );
  p = base; 
 }
  // get a pointer
 // make sure that you allign!
 inline void * alloc( int quantity )
 {
	  void * rv = p;
   (int&)p += round_up( quantity, 4);
	  assert( p < &base[size] );
   return rv;
 }

};

//
// allocate data from a static_buffer
//
template <class T, class buffer >
inline T * d_alloc(const T*, buffer & stk, int count = 1)
{
 return (T*)stk.alloc( (sizeof(T)*count) );
}




#endif